<script lang="ts">
  import { Gql } from '@db';
  import LabeledContainer from '@components/LabeledContainer.svelte';
  import Markdown from '@components/Markdown/Markdown.svelte';
  import EditMarkdown from '@components/Markdown/EditMarkdown.svelte';
  import type { Check } from '@models/Service';

  export let checkId: string;
  export let edit = false;
  $: promise = getCheck(checkId);

  const query = `query GetCheck($check_id: uuid!) {
    checks_checks_by_pk(id: $check_id) {
      id
      name
      display_name
      description
      details
    }
  }`;

  type CheckResponse = {
    checks_checks_by_pk: {
      id: string;
      name: string;
      display_name: string;
      description?: string;
      details?: string;
    };
  };

  async function getCheck(id: string) {
    const data = await Gql.query<CheckResponse>(query, { variables: { check_id: id } });
    if (!data.checks_checks_by_pk) {
      throw new Error(`Check ID not found`);
    }
    return data.checks_checks_by_pk;
  }

  async function updateCheck(check: { id: string; description?: string; details?: string }) {
    promise = Gql.query<{ update_checks_checks_by_pk: Check }>(
      `mutation UpdateCheck($id: uuid!, $check: checks_checks_set_input!) {
      update_checks_checks_by_pk(pk_columns: { id: $id }, _set: $check) {
        id
        name
        display_name
        description
        details
      }
    }`,
      { variables: { id: check.id, check } },
    ).then((data) => data.update_checks_checks_by_pk);
  }
</script>

{#await promise}
  <p>Loading...</p>
{:then info}
  <h1>{info.display_name}</h1>
  <LabeledContainer collapsable label="Description">
    <div class="p-4 pb-2">
      {#if edit}
        <EditMarkdown
          multiline
          minHeight="20vh"
          text={info.description || ''}
          on:save={(e) => updateCheck({ id: info.id, description: e.detail })}
        />
      {:else if info.description}
        <Markdown source={info.description} />
      {:else}
        No description provided. Mysterious!
      {/if}
    </div>
  </LabeledContainer>
  {#if edit}
    <EditMarkdown
      multiline
      minHeight="80vh"
      text={info.details || ''}
      on:save={(e) => updateCheck({ id: info.id, details: e.detail })}
    />
  {:else if info.details}
    <Markdown source={info.details} />
  {:else}
    <p>No detailed scoring information available.</p>
  {/if}
{:catch e}
  <p>Could not load scoring information!</p>
  {#if e && Array.isArray(e) && e[0].message}
    <p>{e[0].message}</p>
  {/if}
{/await}
